#  Authors     [Robert Meolic (robert@meolic.com)]
#  Revision    [$Revision: 188 $]
#  Date        [$Date: 2019-02-07 15:11:19 +0100 (čet, 07 feb 2019) $]
#
#  Copyright   [This file is part of EST (Efficient Symbolic Tools).
#               Copyright (C) 2003, 2019
#               UM-FERI, Koroska cesta 46, SI-2000 Maribor, Slovenia
#
#               EST is free software; you can redistribute it and/or modify
#               it under the terms of the GNU General Public License as
#               published by the Free Software Foundation; either version 2
#               of the License, or (at your option) any later version.
#
#               EST is distributed in the hope that it will be useful,
#               but WITHOUT ANY WARRANTY; without even the implied warranty of
#               MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#               GNU General Public License for more details.
#
#               You should have received a copy of the GNU General Public
#               License along with this program; if not, write to the Free
#               Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
#               Boston, MA 02110-1301 USA.]

global MENU
global MENUITEMS
global MENUBG
global MENUFG

set MENUBDD $MENU.bdd
menu $MENUBDD -activeborderwidth 1 -activebackground #ffffc0 -activeforeground #000040 -font MENUFONT -relief groove -borderwidth 4 -tearoff false
$MENU insert [expr [$MENU index last]] cascade -menu $MENUBDD -activebackground #ffffc0 -activeforeground #000040 -font MENUFONT -label "Bdd"

$MENUBDD add command  -command menu_bdd_terminals -label "bdd_terminals"
$MENUBDD add command  -command menu_bdd_eval1 -label "bdd_eval1"
$MENUBDD add command  -command menu_bdd_eval2 -label "bdd_eval2"
$MENUBDD add separator
$MENUBDD add command  -command menu_bdd_NOT -label "bdd_NOT"
$MENUBDD add command  -command menu_bdd_AND -label "bdd_AND"
$MENUBDD add command  -command menu_bdd_OR -label "bdd_OR"
$MENUBDD add command  -command menu_bdd_XOR -label "bdd_XOR"
$MENUBDD add command  -command menu_bdd_ITE -label "bdd_ITE"
$MENUBDD add command  -command menu_bdd_E -label "bdd_E"
$MENUBDD add command  -command menu_bdd_A -label "bdd_A"
$MENUBDD add command  -command menu_bdd_restrict -label "bdd_restrict"
$MENUBDD add command  -command menu_bdd_compose -label "bdd_compose"
$MENUBDD add separator
$MENUBDD add command  -command menu_bdd_outBDD -label "bdd_out_BDD"
$MENUBDD add command  -command menu_bdd_outTable -label "bdd_out_table"
$MENUBDD add command  -command menu_bdd_outFunction -label "bdd_out function"
$MENUBDD add command  -command menu_bdd_drawBDD -label "bdd_draw_BDD"
$MENUBDD add separator
$MENUBDD add cascade  -label "Functions..." -menu $MENUBDD.functions
$MENUBDD add cascade  -label "Node table..." -menu $MENUBDD.nodeTable
$MENUBDD add cascade  -label "Hash tables..." -menu $MENUBDD.hashTables
$MENUBDD add cascade  -label "Memory management..." -menu $MENUBDD.memory
$MENUBDD add separator
$MENUBDD add command  -command bdd_about -label "bdd_about"

menu $MENUBDD.functions -activeborderwidth 1 -activebackground #ffffc0 -activeforeground #000040 -font MENUFONT -relief groove -borderwidth 4 -tearoff false
$MENUBDD.functions add command  -command menu_bdd_cmp -label "bdd_cmp"
$MENUBDD.functions add command  -command menu_bdd_find -label "bdd_find"
$MENUBDD.functions add command  -command menu_bdd_support -label "bdd_support"
$MENUBDD.functions add command  -command menu_bdd_nodeNumber -label "bdd_node_number"
$MENUBDD.functions add command  -command menu_bdd_nodeNumberPlain -label "bdd_node_number_plain"
$MENUBDD.functions add command  -command menu_bdd_nodeMaxLevel -label "bdd_node_max_level"
$MENUBDD.functions add command  -command menu_bdd_nodeAvgLevel -label "bdd_node_avg_level"
$MENUBDD.functions add command  -command menu_bdd_variableNumber -label "bdd_variable_number"
$MENUBDD.functions add command  -command menu_bdd_mintermCount -label "bdd_minterm_count"

menu $MENUBDD.nodeTable -activeborderwidth 1 -activebackground #ffffc0 -activeforeground #000040 -font MENUFONT -relief groove -borderwidth 4 -tearoff false
$MENUBDD.nodeTable add command  -command menu_bdd_tableSize -label "bdd_table_size"
$MENUBDD.nodeTable add command  -command menu_bdd_tableMax -label "bdd_table_max"
$MENUBDD.nodeTable add command  -command menu_bdd_tableNumber -label "bdd_table_number"
$MENUBDD.nodeTable add command  -command menu_bdd_listUsed -label "bdd_list_used"
$MENUBDD.nodeTable add command  -command menu_bdd_listMaxLength -label "bdd_list_max_length"
$MENUBDD.nodeTable add command  -command menu_bdd_listAvgLength -label "bdd_list_avg_length"

menu $MENUBDD.hashTables -activeborderwidth 1 -activebackground #ffffc0 -activeforeground #000040 -font MENUFONT -relief groove -borderwidth 4 -tearoff false
$MENUBDD.hashTables add command  -command menu_bdd_cacheITEFind -label "bdd_cache_ITE_find"
$MENUBDD.hashTables add command  -command menu_bdd_cacheITEInsert -label "bdd_cache_ITE_insert"
$MENUBDD.hashTables add command  -command menu_bdd_cacheITEOverwrite -label "bdd_cache_ITE_overwrite"
$MENUBDD.hashTables add command  -command menu_bdd_cacheRelOpFind -label "bdd_cache_RelOp_find"
$MENUBDD.hashTables add command  -command menu_bdd_cacheRelOpOverwrite -label "bdd_cache_RelOp_overwrite"
$MENUBDD.hashTables add command  -command menu_bdd_cacheRelOpSimpleFind -label "bdd_cache_RelOpSimple_find"
$MENUBDD.hashTables add command  -command menu_bdd_cacheRelOpSimpleOverwrite -label "bdd_cache_RelOpSimple_overwrite"
$MENUBDD.hashTables add command  -command menu_bdd_cacheRelOpComplexFind -label "bdd_cache_RelOpComplex_find"
$MENUBDD.hashTables add command  -command menu_bdd_cacheRelOpComplexOverwrite -label "bdd_cache_RelOpComplex_overwrite"
$MENUBDD.hashTables add command  -command menu_bdd_cacheStabRSFind -label "bdd_cache_StabRS_find"
$MENUBDD.hashTables add command  -command menu_bdd_cacheStabRSOverwrite -label "bdd_cache_StabRS_overwrite"

menu $MENUBDD.memory -activeborderwidth 1 -activebackground #ffffc0 -activeforeground #000040 -font MENUFONT -relief groove -borderwidth 4 -tearoff false
$MENUBDD.memory add command  -command menu_bdd_memoryInUse -label "bdd_memory_in_use"
$MENUBDD.memory add command  -command menu_bdd_blockNumber -label "bdd_block_number"
$MENUBDD.memory add command  -command menu_bdd_nodeGenerated -label "bdd_node_generated"
$MENUBDD.memory add command  -command menu_bdd_garbageNumber -label "bdd_garbage_number"
$MENUBDD.memory add command  -command menu_bdd_swapNumber -label "bdd_swap_number"
$MENUBDD.memory add command  -command menu_bdd_siftingNumber -label "bdd_sifting_number"
$MENUBDD.memory add separator
$MENUBDD.memory add command  -command menu_bdd_printInfo -label "bdd_print_info"

lappend MENUITEMS $MENUBDD
lappend MENUITEMS $MENUBDD.functions
lappend MENUITEMS $MENUBDD.nodeTable
lappend MENUITEMS $MENUBDD.hashTables
lappend MENUITEMS $MENUBDD.memory
refresh

proc bdd_about {  } {
    global BINDIR

    outline ""
    outline "\#\#\# "
    out "\# "
    bdd_aboutPkg

    set OK ""
    if {[file isfile "/usr/lib/est2ed/bdd.about"]} {
      set OK "OK"
      set f [open "/usr/lib/est2ed/bdd.about" r]
    } else {
      if {[file isfile "$BINDIR/bdd.about"]} {
        set OK "OK"
        set f [open "$BINDIR/bdd.about" r]
      }
    }

    if { $OK == "OK" } {
      while {[gets $f line] >= 0} {
        out "\# "
        outline $line
      }
      outline "\#\#\# "
      close $f
    }
}

proc bdd_stat2 { } {
  outline "Statistic about BDD package"
  outline "NODE TABLE:"
  out "  bdd_table_max: "
  outline [bdd_table_max]
  out "  bdd_table_number: "
  outline [bdd_table_number]
  out "  bdd_list_used: "
  outline [bdd_list_used]
  out "  bdd_list_max_length: "
  outline [bdd_list_max_length]
  out "  bdd_list_avg_length: "
  outline [bdd_list_avg_length]
  outline "ITE CACHE:"
  out "  bdd_cache_ITE_search: "
  outline [bdd_cache_ITE_search]
  out "  bdd_cache_ITE_find: "
  outline [bdd_cache_ITE_find]
  out "  bdd_cache_ITE_insert: "
  outline [bdd_cache_ITE_insert]
  out "  bdd_cache_ITE_overwrite: "
  outline [bdd_cache_ITE_overwrite]
  outline "RELOP CACHE:"
  out "  bdd_cache_RelOp_num: "
  outline [bdd_cache_RelOp_num]
  out "  bdd_cache_RelOp_search: "
  outline [bdd_cache_RelOp_search]
  out "  bdd_cache_RelOp_find: "
  outline [bdd_cache_RelOp_find]
  out "  bdd_cache_RelOp_overwrite: "
  outline [bdd_cache_RelOp_overwrite]
  outline "RELOPSIMPLE CACHE:"
  out "  bdd_cache_RelOpSimple_num: "
  outline [bdd_cache_RelOpSimple_num]
  out "  bdd_cache_RelOpSimple_search: "
  outline [bdd_cache_RelOpSimple_search]
  out "  bdd_cache_RelOpSimple_find: "
  outline [bdd_cache_RelOpSimple_find]
  out "  bdd_cache_RelOpSimple_overwrite: "
  outline [bdd_cache_RelOpSimple_overwrite]
  outline "RELOPCOMPLEX CACHE:"
  out "  bdd_cache_RelOpComplex_num: "
  outline [bdd_cache_RelOpComplex_num]
  out "  bdd_cache_RelOpComplex_search: "
  outline [bdd_cache_RelOpComplex_search]
  out "  bdd_cache_RelOpComplex_find: "
  outline [bdd_cache_RelOpComplex_find]
  out "  bdd_cache_RelOpComplex_overwrite: "
  outline [bdd_cache_RelOpComplex_overwrite]
  outline "STABRS CACHE:"
  out "  bdd_cache_StabRS_search: "
  outline [bdd_cache_StabRS_search]
  out "  bdd_cache_StabRS_find: "
  outline [bdd_cache_StabRS_find]
  out "  bdd_cache_StabRS_overwrite: "
  outline [bdd_cache_StabRS_overwrite]
  outline "MEMORY MANAGEMENT:"
  out "  bdd_memory_in_use: "
  outline [bdd_memory_in_use]
  out "  bdd_block_number: "
  outline [bdd_block_number]
  out "  bdd_node_generated: "
  outline [bdd_node_generated]
  out "  bdd_garbage_number: "
  outline [bdd_garbage_number]
  out "  bdd_swap_number: "
  outline [bdd_swap_number]
  out "  bdd_sifting_number: "
  outline [bdd_sifting_number]
  outline ""
}

# ##########################################################
# FIELD1: Initial string/value
# FIELD2: List of arguments/values (where applicable)
#
# BROWSE types defined in mi.tcl
#
# file%s        filename
# boolean%s     false or true
# term%s        list of given terminals
# optional%s    optional parameter, can be left out
# required%s    required parameter, if empty then use ""
# nonempty%s    required parameter, must not be equal to ""
#
# BROWSE types defined in bddDialog.tcl
#
# bdd%s         BDD formulae name
#
# ##########################################################

global BROWSETYPE

if {[string compare [string range $tcl_patchLevel 0 2] "8.4"] < 0} {
  array set BROWSETYPE {bdd {{list {Select...}} {lindex $item 2} {bddBrowse}}}
} else {
  dict set BROWSETYPE bdd {{list {Select...}} {lindex $item 2} {bddBrowse}}
}

proc bddBrowse {  } {
  global MENUFG
  global MENUBG
  global FIELD1
  global FIELD2
  global FIELD3
  global IFIELD
  global tcl_patchLevel

  if {[info exists FIELD3($IFIELD)]} {unset FIELD3($IFIELD)}
  set FIELD3($IFIELD) $FIELD1($IFIELD)

  set list ""
  set list2 [bdd_list_formulae]

  while {[llength $list2] != 0} {
    set item [lindex $list2 0]
    set iprefix [string first "_" $item]
    if {$iprefix == -1} {
      set list1 $item
      set list2 [lsearch -all -inline -exact -not $list2 $item]
    } else {
      set prefix [string range $item 0 $iprefix]
      set list1 [lsearch -all -inline $list2 "$prefix*"]
      set list1 [linsert $list1 0 $prefix]
      set list2 [lsearch -all -inline -not $list2 "$prefix*"]
    }
    if {($list1 != "0") && ($list1 != "1")} {
      lappend list $list1
    }
  }

  set menu [eval tk_optionCascade .commonDialog.dialogFrame.browse.$IFIELD.field FIELD3($IFIELD) {$FIELD1($IFIELD)} $list]

  if {[string compare [string range $tcl_patchLevel 0 2] "8.4"] < 0} {
    trace variable FIELD3($IFIELD) w refreshCmd
  } else {
    trace add variable FIELD3($IFIELD) write refreshCmd
  }
}

proc menu_bdd_terminals {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_terminals"
    set SYNOPSIS "Create terminal nodes"
    set SYNTAX "vlist%s"
    set EXAMPLE "bdd_terminals \"A B C\""
    set EXPLANATION "Create terminals with variables A, B, and C"
    set BROWSE [list \
        {nonempty "List of variable names" 30} \
    ]

    set CMD $NAME
    set CMDEND ""

    commonDialog
}

proc menu_bdd_eval1 {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_eval1"
    set SYNOPSIS "Evaluate prefix AND-OR-EXOR-NOT format"
    set SYNTAX "\"eval1%s\" fname%s"
    set EXAMPLE "bdd_eval1 \"(AND A B)\" F1"
    set EXPLANATION "Calculate and store F1 = (AND A B)"
    set BROWSE [list \
        {nonempty "Expression (prefix notation)" 30} \
        {nonempty "Result" 30} \
    ]

    set CMD $NAME
    set CMDEND ""

    commonDialog
}

proc menu_bdd_eval2 {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_eval2"
    set SYNOPSIS "Evaluate infix *+!^>- format"
    set SYNTAX "\"eval2%s\" fname%s"
    set EXAMPLE "bdd_eval2 x*y+!x*z F1"
    set EXPLANATION "Calculate and store F1 = x*y+!x*z"
    set BROWSE [list \
        {nonempty "Expression (infix notation)" 30} \
        {nonempty "Result" 30} \
    ]

    set CMD $NAME
    set CMDEND ""

    commonDialog
}

proc menu_bdd_NOT {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_NOT"
    set SYNOPSIS "Calculate negation."
    set SYNTAX "fname%s fname%s"
    set EXAMPLE "bdd_NOT F1 F2"
    set EXPLANATION "Calculate and store F2 = NOT F1"
    set BROWSE [list \
        {bdd "Function"} \
        {nonempty "Result" 30} \
    ]

    set CMD $NAME
    set CMDEND ""

    commonDialog
}

proc menu_bdd_AND {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_AND"
    set SYNOPSIS "Calculate conjunction."
    set SYNTAX "fname%s fname%s fname%s"
    set EXAMPLE "bdd_AND F1 F2 F3"
    set EXPLANATION "Calculate and store F3 = F1 AND F2"
    set BROWSE [list \
        {bdd "Function"} \
        {bdd "Function"} \
        {nonempty "Result" 30} \
    ]

    set CMD $NAME
    set CMDEND ""

    commonDialog
}

proc menu_bdd_OR {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_OR"
    set SYNOPSIS "Calculate disjunction."
    set SYNTAX "fname%s fname%s fname%s"
    set EXAMPLE "bdd_OR F1 F2 F3"
    set EXPLANATION "Calculate and store F3 = F1 OR F2"
    set BROWSE [list \
        {bdd "Function"} \
        {bdd "Function"} \
        {nonempty "Result" 30} \
    ]

    set CMD $NAME
    set CMDEND ""

    commonDialog
}

proc menu_bdd_XOR {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_XOR"
    set SYNOPSIS "Calculate exclusive sum."
    set SYNTAX "fname%s fname%s fname%s"
    set EXAMPLE "bdd_XOR F1 F2 F3"
    set EXPLANATION "Calculate and store F3 = F1 XOR F2"
    set BROWSE [list \
        {bdd "Function"} \
        {bdd "Function"} \
        {nonempty "Result" 30} \
    ]

    set CMD $NAME
    set CMDEND ""

    commonDialog
}

proc menu_bdd_ITE {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_ITE"
    set SYNOPSIS "Calculate ITE operation."
    set SYNTAX "fname%s fname%s fname%s fname%s"
    set EXAMPLE "bdd_ITE F G H R"
    set EXPLANATION "Calculate and store R = ITE(F,G,H)"
    set BROWSE [list \
        {bdd "Function F"} \
        {bdd "Function G"} \
        {bdd "Function H"} \
        {nonempty "Result" 30} \
    ]

    set CMD $NAME
    set CMDEND ""

    commonDialog
}

proc menu_bdd_E {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_E"
    set SYNOPSIS "Calculate existential quantification."
    set SYNTAX "vlist%s fname%s fname%s"
    set EXAMPLE "bdd_E \"P R\" F1 F2"
    set EXPLANATION "Calculate and store F2 = ExP ExR (F1)"
    set BROWSE [list \
        {nonempty "List of variable names" 30} \
        {bdd "Function"} \
        {nonempty "Result" 30} \
    ]

    set CMD $NAME
    set CMDEND ""

    commonDialog
}

proc menu_bdd_A {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_A"
    set SYNOPSIS "Calculate universal quantification."
    set SYNTAX "vlist%s fname%s fname%s"
    set EXAMPLE "bdd_A \"P R\" F1 F2"
    set EXPLANATION "Calculate and store F2 = AxP AxR (F1)"
    set BROWSE [list \
        {nonempty "List of variable names" 30} \
        {bdd "Function"} \
        {nonempty "Result" 30} \
    ]

    set CMD $NAME
    set CMDEND ""

    commonDialog
}

proc menu_bdd_restrict {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_restrict"
    set SYNOPSIS "Calculate restriction."
    set SYNTAX "vname%s term%d fname%s fname%s"
    set EXAMPLE "bdd_restrict F1 A 1 G"
    set EXPLANATION "Calculate and store G = F1_(A=1)"
    set BROWSE [list \
        {bdd "Original function"} \
        {nonempty "Variable name" 30} \
        {term "Variable value" "0 1"} \
        {nonempty "Result" 30} \
    ]

    set CMD $NAME
    set CMDEND ""

    commonDialog
}

proc menu_bdd_compose {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_compose"
    set SYNOPSIS "Calculate composition."
    set SYNTAX "fname%s vname%s fname%s fname%s"
    set EXAMPLE "bdd_compose F1 A F2 F3"
    set EXPLANATION "Calculate and store F3 = F1_(A=F2)"
    set BROWSE [list \
        {bdd "Original function"} \
        {nonempty "Variable name" 30} \
        {bdd "Function"} \
        {nonempty "Result" 30} \
    ]

    set CMD $NAME
    set CMDEND ""

    commonDialog
}

proc menu_bdd_outBDD {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_out_BDD"
    set SYNOPSIS "Write BDD."
    set SYNTAX "fname%s"
    set EXAMPLE "bdd_out_BDD F1"
    set EXPLANATION "Write BDD of Boolean function F1"
    set BROWSE [list \
        {bdd "Function"} \
    ]

    set CMD $NAME
    set CMDEND ""

    commonDialog
}

proc menu_bdd_outTable {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_out_table"
    set SYNOPSIS "Write truth table."
    set SYNTAX "fname%s"
    set EXAMPLE "bdd_out_table F1"
    set EXPLANATION "Write truth table for Boolean function F1"
    set BROWSE [list \
        {bdd "Function"} \
    ]

    set CMD $NAME
    set CMDEND ""

    commonDialog
}

proc menu_bdd_outFunction {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_out_function"
    set SYNOPSIS "Write Boolean function."
    set SYNTAX "fname%s"
    set EXAMPLE "bdd_out_function F1"
    set EXPLANATION "Write AND-OR form of Boolean function F1"
    set BROWSE [list \
        {bdd "Function"} \
    ]

    set CMD $NAME
    set CMDEND ""

    commonDialog
}

proc menu_bdd_drawBDD {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_draw_BDD"
    set SYNOPSIS "Draw BDD."
    set SYNTAX "fname%s"
    set EXAMPLE "bdd_draw_BDD F1"
    set EXPLANATION "Draw BDD of Boolean function F1"
    set BROWSE [list \
        {bdd "Function"} \
    ]

    set CMD $NAME
    set CMDEND ""

    commonDialog
}

proc menu_bdd_cmp {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_cmp"
    set SYNOPSIS "Compare two BDDs."
    set SYNTAX "fname%s fname%s"
    set EXAMPLE "outline \[bdd_cmp F1 F2\]"
    set EXPLANATION "Return \"true\" if equal, otherwise \"false\""
    set BROWSE [list \
        {bdd "Function 1"} \
        {bdd "Function 2"} \
    ]

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_find {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_find"
    set SYNOPSIS "Check if there exists BDD with given name."
    set SYNTAX "fname%s"
    set EXAMPLE "outline \[bdd_find F1\]"
    set EXPLANATION "Return \"true\" or \"false\""
    set BROWSE [list \
        {nonempty "Function" 30} \
    ]

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_support {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_support"
    set SYNOPSIS "Calculate product of all dependent variables."
    set SYNTAX "fname%s fname%s"
    set EXAMPLE "bdd_support F SUPF"
    set EXPLANATION "Calculate and store SUPF = product of all dependent variables in F"
    set BROWSE [list \
        {bdd "Function"} \
        {nonempty "Result" 30} \
    ]

    set CMD $NAME
    set CMDEND ""

    commonDialog
}

proc menu_bdd_nodeNumber {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_node_number"
    set SYNOPSIS "Find the number of nodes."
    set SYNTAX "fname%s"
    set EXAMPLE "outline \[bdd_node_number F1\]"
    set EXPLANATION "Return number of nodes of BDD representing function F1"
    set BROWSE [list \
        {bdd "Function"} \
    ]

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_nodeNumberPlain {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_node_number_plain"
    set SYNOPSIS "Find the number of nodes in a corresponding BDD without complemented edges"
    set SYNTAX "fname%s"
    set EXAMPLE "outline \[bdd_node_number_plain F1\]"
    set EXPLANATION "Return number of nodes of BDD without complemented edges representing function F1 "
    set BROWSE [list \
        {bdd "Function"} \
    ]

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_nodeMaxLevel {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_node_max_level"
    set SYNOPSIS "Find the maximal depth of BDD."
    set SYNTAX "fname%s"
    set EXAMPLE "outline \[bdd_node_max_level F1\]"
    set EXPLANATION "Return maximal depth of BDD representing function F1"
    set BROWSE [list \
        {bdd "Function"} \
    ]

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_nodeAvgLevel {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_node_avg_level"
    set SYNOPSIS "Find the average depth of BDD."
    set SYNTAX "fname%s"
    set EXAMPLE "outline \[bdd_node_avg_level F1\]"
    set EXPLANATION "Return average depth of BDD representing function F1"
    set BROWSE [list \
        {bdd "Function"} \
    ]

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_variableNumber {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_variable_number"
    set SYNOPSIS "Find the number of variables on which a BDD depends."
    set SYNTAX "fname%s"
    set EXAMPLE "outline \[bdd_variable_number F1\]"
    set EXPLANATION "Return number of variables on which depends a BDD representing function F1"
    set BROWSE [list \
        {bdd "Function"} \
    ]

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_mintermCount {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_minterm_count"
    set SYNOPSIS "Count minterms in the function represented by a BDD."
    set SYNTAX "fname%s"
    set EXAMPLE "outline \[bdd_minterm_count F1 4\]"
    set EXPLANATION "Return the number of minterms in function F1 assuming it depends on 4 variables"
    set BROWSE [list \
        {bdd "Function"} \
        {optional "Number of variables (optional)" 8} \
    ]

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_tableSize {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_table_size"
    set SYNOPSIS "Size of node table."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_table_size\]"
    set EXPLANATION "Return size of node table"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_tableMax {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_table_max"
    set SYNOPSIS "Maximal number of nodes in node table."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_table_max\]"
    set EXPLANATION "Return maximal number of nodes in node table"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_tableNumber {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_table_number"
    set SYNOPSIS "Count all nodes in node table."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_table_number\]"
    set EXPLANATION "Return number of all nodes in node table"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_listUsed {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_list_used"
    set SYNOPSIS "Count nonempty lists in node table."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_list_used\]"
    set EXPLANATION "Return number of nonempty lists"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_listMaxLength {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_list_max_length"
    set SYNOPSIS " Count nodes in the longest list."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_list_max_length\]"
    set EXPLANATION "Return number of nodes in the longest list"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_listAvgLength {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_list_avg_length"
    set SYNOPSIS "Calculate average length of lists."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_list_avg_length\]"
    set EXPLANATION "Return average number of nodes in lists"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_cacheITEFind {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_cache_ITE_find"
    set SYNOPSIS "Number of succesful lookups in ITE cache table."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_cache_ITE_find\]"
    set EXPLANATION "Return number of succesful lookups in ITE cache table"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_cacheITEInsert {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_cache_ITE_insert"
    set SYNOPSIS "Number of insertions in ITE cache table."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_cache_ITE_insert\]"
    set EXPLANATION "Return number of insertions in ITE cache table"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_cacheITEOverwrite {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_cache_ITE_overwrite"
    set SYNOPSIS "Number of overwritten items in ITE cache table."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_cache_ITE_overwrite\]"
    set EXPLANATION "Return number of overwritten items in ITE cache table"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_cacheRelOpFind {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_cache_RelOp_find"
    set SYNOPSIS "Number of succesful lookups in RelOp cache table."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_cache_RelOp_find\]"
    set EXPLANATION "Return number of succesful lookups in RelOp cache table"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_cacheRelOpOverwrite {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_cache_RelOp_overwrite"
    set SYNOPSIS "Number of overwritten items in RelOp cache table."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_cache_RelOp_overwrite\]"
    set EXPLANATION "Return number of overwritten items in RelOp cache table"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_cacheRelOpSimpleFind {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_cache_RelOpSimple_find"
    set SYNOPSIS "Number of succesful lookups in RelOpSimple cache table."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_cache_RelOpSimple_find\]"
    set EXPLANATION "Return number of succesful lookups in RelOpSimple cache table"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_cacheRelOpSimpleOverwrite {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_cache_RelOpSimple_overwrite"
    set SYNOPSIS "Number of overwritten items in RelOpSimple cache table."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_cache_RelOpSimple_overwrite\]"
    set EXPLANATION "Return number of overwritten items in RelOpSimple cache table"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_cacheRelOpComplexFind {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_cache_RelOpComplex_find"
    set SYNOPSIS "Number of succesful lookups in RelOpComplex cache table."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_cache_RelOpComplex_find\]"
    set EXPLANATION "Return number of succesful lookups in RelOpComplex cache table"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_cacheRelOpComplexOverwrite {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_cache_RelOpComplex_overwrite"
    set SYNOPSIS "Number of overwritten items in RelOpComplex cache table."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_cache_RelOpComplex_overwrite\]"
    set EXPLANATION "Return number of overwritten items in RelOpComplex cache table"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_cacheStabRSFind {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_cache_StabRS_find"
    set SYNOPSIS "Number of succesful lookups in StabRS cache table."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_cache_StabRS_find\]"
    set EXPLANATION "Return number of succesful lookups in StabRS cache table"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_cacheStabRSOverwrite {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_cache_StabRS_overwrite"
    set SYNOPSIS "Number of overwritten items in StabRS cache table."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_cache_StabRS_overwrite\]"
    set EXPLANATION "Return number of overwritten items in StabRS cache table"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_blockNumber {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_block_number"
    set SYNOPSIS "Number of allocated memory blocks."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_block_number\]"
    set EXPLANATION "Return number of allocated memory blocks"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_nodeGenerated {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_node_generated"
    set SYNOPSIS "Number of generated nodes"
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_node_generated\]"
    set EXPLANATION "Return number of generated nodes."
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_memoryInUse {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_memory_in_use"
    set SYNOPSIS "The amount of allocated memory in bytes."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_memory_in_use\]"
    set EXPLANATION "Return the amount of allocated memory"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_garbageNumber {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_garbage_number"
    set SYNOPSIS "Number of garbage collections."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_garbage_number\]"
    set EXPLANATION "Return number of garbage collections"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_swapNumber {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_swap_number"
    set SYNOPSIS "Number of variable swapping."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_swap_number\]"
    set EXPLANATION "Return number of variable swapping"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_siftingNumber {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_sifting_number"
    set SYNOPSIS "Number of variable reorderings by sifting."
    set SYNTAX ""
    set EXAMPLE "outline \[bdd_sifting_number\]"
    set EXPLANATION "Return number of variable reorderings by sifting"
    set BROWSE ""

    set CMD "outline \[$NAME"
    set CMDEND "\]"

    commonDialog
}

proc menu_bdd_printInfo {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "bdd_print_info"
    set SYNOPSIS "Stats about the Biddy package."
    set SYNTAX ""
    set EXAMPLE "bdd_print_info"
    set EXPLANATION "Prints stats about the Biddy package."
    set BROWSE ""

    set CMD "$NAME"
    set CMDEND ""

    commonDialog
}
