#  Authors     [Robert Meolic (robert@meolic.com)]
#  Revision    [$Revision: 188 $]
#  Date        [$Date: 2019-02-07 15:11:19 +0100 (čet, 07 feb 2019) $]
#
#  Copyright   [This file is part of EST (Efficient Symbolic Tools).
#               Copyright (C) 2003, 2019
#               UM-FERI, Koroska cesta 46, SI-2000 Maribor, Slovenia
#
#               EST is free software; you can redistribute it and/or modify
#               it under the terms of the GNU General Public License as
#               published by the Free Software Foundation; either version 2
#               of the License, or (at your option) any later version.
#
#               EST is distributed in the hope that it will be useful,
#               but WITHOUT ANY WARRANTY; without even the implied warranty of
#               MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#               GNU General Public License for more details.
#
#               You should have received a copy of the GNU General Public
#               License along with this program; if not, write to the Free
#               Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
#               Boston, MA 02110-1301 USA.]

global MENU
global MENUITEMS
global MENUBG
global MENUFG

set MENUVERILOG $MENU.verilog
menu $MENUVERILOG -activeborderwidth 1 -activebackground #ffffc0 -activeforeground #000040 -font MENUFONT -relief groove -borderwidth 4 -tearoff false
$MENU insert [expr [$MENU index last]] cascade -menu $MENUVERILOG -activebackground #ffffc0 -activeforeground #000040 -font MENUFONT -label "Verilog"

$MENUVERILOG add command -command menu_verilog_convert_to_ccs -label "verilog_convert_to_ccs"
$MENUVERILOG add separator
$MENUVERILOG add command  -command verilog_about -label "verilog_about"

lappend MENUITEMS $MENUVERILOG
refresh

proc verilog_about {  } {
    global BINDIR

    outline ""
    outline "\#\#\# "
    out "\# "
    verilog_aboutPkg

    set OK ""
    if {[file isfile "/usr/lib/est2ed/verilog.about"]} {
      set OK "OK"
      set f [open "/usr/lib/est2ed/verilog.about" r]
    } else {
      if {[file isfile "$BINDIR/verilog.about"]} {
        set OK "OK"
        set f [open "$BINDIR/verilog.about" r]
      }
    }

    if { $OK == "OK"} {
      while {[gets $f line] >= 0} {
        out "\# "
        outline $line
      }
      outline "\#\#\# "
      close $f
    }
}

# ##########################################################
# FIELD1: Initial string/value
# FIELD2: List of arguments/values (where applicable)
#
# BROWSE types defined in mi.tcl
#
# file%s        filename
# boolean%s     false or true
# term%s        list of given terminals
# optional%s    optional parameter, can be left out
# required%s    required parameter, if empty then use ""
# nonempty%s    required parameter, must not be equal to ""
#
# BROWSE types defined in paDialog.tcl
#
# name%s        sort/process/composition name
# list%s        list of sorts/processes/compositions
#
# BROWSE types defined in versisDialog.tcl
#
# comtype%d     composition type
#
# BROWSE types defined in mcDialog.tcl
#
# form%s        formula
#
# ##########################################################

proc menu_verilog_convert_to_ccs {  } {
    global NAME
    global SYNOPSIS
    global SYNTAX
    global EXAMPLE
    global EXPLANATION
    global BROWSE
    global CMD
    global CMDEND

    set NAME "verilog_convert_to_ccs"
    set SYNOPSIS "Read Verilog netlist and represent it with CCS."
    set SYNTAX "fname%s"
    set EXAMPLE "verilog_convert_to_ccs iscas85/c17.v"
    set EXPLANATION "Convert Verilog netlist from file ./iscas85/c17.v"
    set BROWSE [list \
        {file "Select file with Verilog netlist" {{{Verilog model} {.v}} {{All files} {*.*}}}} \
        {nonempty "Output file" 60} \
    ]

    set CMD $NAME
    set CMDEND ""

    commonDialog
}
