# /* Crossing */
# /* Robert Meolic, last modified 10 Aug 2017 */

# RESULTS FOR PAPER - COUNTEREXAMPLES FOR SECOND VARIANT OF THE CROSSING
#mc_read_actl_file crossing.actl
#ccs_read crossing1.ccs
#mc_check_actl 1 SY F4Y
#mc_check_actl 1 SY F6
#mc_check_actl 1 SY F9
#stop

# TESTING FOR PAPER - TABLE 1
#set num 6
#mc_read_actl_file crossing.actl
#ccs_read crossing2.ccs
#bdd_stat
#for {set i 1} {$i <= 10} {incr i} {
#  out "## F$i ## "
#  mc_check_actl 1 SW$num F$i
#}
#bdd_stat
#out "Number of states in the composition: "
#outline [pa_comp_state_number SW$num]
#out "Number of transitions in the composition: "
#outline [pa_comp_transition_number SW$num]
#out "Number of BDD nodes for the composition: "
#outline [bdd_node_number D_COMP_SW$num]
#stop

# RESULTS FOR PAPER - TABLE 1
# YOU HAVE TO UNCOMMENT THE APPROPRIATE SECTION IN crossing2.ccs
set num 6
mc_read_actl_file crossing.actl
ccs_read crossing2.ccs
mc_check_actl 1 SW$num F9
#mc_check_actl 1 SW$num F10X$num
out "Number of states in the composition: "
outline [pa_comp_state_number SW$num]
out "Number of transitions in the composition: "
outline [pa_comp_transition_number SW$num]
out "Number of BDD nodes for the composition: "
outline [bdd_node_number D_COMP_SW$num]
bdd_stat
stop

# OLD VERSION (Krizisce - iz magisterija, Robert Meolic)
#pa_read_process "crossing.dat"
#pa_encode_process "cross train car"
#versis_compose 0 crossing \
#  "cross train car" \
#  "isClose isOpen isRed isGreen lower raise"

# UPDATED VERSION (Crossing, Robert Meolic)
ccs_read crossing.ccs

# MODEL CHECKING

mc_read_actl_file crossing.actl

# RESULTS FOR PAPER - SECTION 5
#mc_check_actl 1 SX F8 [expr $::mc_diagnostic | $::mc_explain]
#mc_check_actl 1 SX F9 [expr $::mc_diagnostic | $::mc_explain]
#mc_check_actl 1 SX F10 [expr $::mc_diagnostic | $::mc_explain]
#mc_check_actl 1 SY F1 [expr $::mc_diagnostic | $::mc_explain]
#mc_check_actl 1 SY F2 [expr $::mc_diagnostic | $::mc_explain]
#mc_check_actl 1 SY F3 [expr $::mc_diagnostic | $::mc_explain]
#mc_check_actl 1 SY F4 [expr $::mc_diagnostic | $::mc_explain]
#mc_check_actl 1 SY F5 [expr $::mc_diagnostic | $::mc_explain]
#mc_check_actl 1 SY F8 [expr $::mc_diagnostic | $::mc_explain]
#mc_check_actl 1 SY F9 [expr $::mc_diagnostic | $::mc_explain]
#mc_check_actl 1 SY F10 [expr $::mc_diagnostic | $::mc_explain]
#mc_check_actl 1 SZ F10 [expr $::mc_diagnostic | $::mc_explain]
#mc_check_actl 1 SZ3 F4 [expr $::mc_diagnostic | $::mc_explain]
#mc_check_actl 1 SZ3 F8 [expr $::mc_diagnostic | $::mc_explain]
#mc_check_actl 1 SZ3 F9 [expr $::mc_diagnostic | $::mc_explain]
#mc_check_actl 1 SZ3 F10 [expr $::mc_diagnostic | $::mc_explain]
#mc_check_actl 1 SW3 F9 [expr $::mc_diagnostic | $::mc_explain]
#mc_check_actl 1 SW3 F10 [expr $::mc_diagnostic | $::mc_explain]
#stop

# SX is is a slighty modified version from R. De Nicola et al, 1993 */
outline "## FIRST VARIANT"
for {set i 1} {$i <= 10} {incr i} {
  out "## F$i ## "
  mc_check_actl 1 SX F$i
}

# SY is from R. Meolic, from his M.Sc. work (1999) */
outline "## SECOND VARIANT"
for {set i 1} {$i <= 10} {incr i} {
  out "## F$i ## "
  mc_check_actl 1 SY F$i
}

# SZ is from R. Meolic, an improved version, a variant with only one car */
outline "## THIRD VARIANT"
for {set i 1} {$i <= 10} {incr i} {
  out "## F$i ## "
  mc_check_actl 1 SZ F$i
}

# SZ3 is from R. Meolic, an improved version, a variant with three cars */
outline "## FOURTH VARIANT"
for {set i 1} {$i <= 10} {incr i} {
  out "## F$i ## "
  mc_check_actl 1 SZ3 F$i
}
out "## F4X ## "
mc_check_actl 1 SZ3 F4X

# SW3 is from R. Meolic, an improved version, a variant with three cars and FIFO */
outline "## FIFTH VARIANT"
for {set i 1} {$i <= 10} {incr i} {
  out "## F$i ## "
  mc_check_actl 1 SW3 F$i
}

#outline "DEBUGGING"
#mc_check_actl 1 SW3 F9 [expr $::mc_diagnostic]
#mc_check_actl 1 SW3 F10 [expr $::mc_diagnostic]
