# Algorithms for mutual exclusion
# This is a subset of the project used to test WebEST
# Robert Meolic, David Dedic, 2002, 2016

pa_read_process "me-david.dat"

pa_encode_process "P1BAKERY P2BAKERY P1BENARI P2BENARI P1STEP P2STEP"
pa_encode_process "B1 B2 N1 N2 N1PLUS N2PLUS NPLUS"

set ::actions "request1 request2 enter1 exit1 enter2 exit2"

outline ""
outline "VERIFICATION OF LAMPORT,S BAKERY ALGORITHM"

versis_compose 1 BAKERY "P1BAKERY P2BAKERY B1 B2 N1 N2 N1PLUS N2PLUS" $::actions
mc_check_actl_file 1 BAKERY "me-david.actl"

outline ""
outline "VERIFICATION OF BEN-ARI,S VARIANT OF BAKERY ALGORITHM"

versis_compose 1 BENARI "P1BENARI P2BENARI N1 N2 N1PLUS N2PLUS" $::actions
mc_check_actl_file 1 BENARI "me-david.actl"

outline ""
outline "VERIFICATION OF THE STeP VARIANT OF BAKERY ALGORITHM"

versis_compose 1 STEP "P1STEP P2STEP N1 N2 N1PLUS N2PLUS" $::actions
mc_check_actl_file 1 STEP "me-david.actl"

outline ""
outline "VERIFICATION OF THE STeP VARIANT OF BAKERY ALGORITHM - ATOMIC INCREMENTATION"

versis_compose 1 STEP2 "P1STEP P2STEP N1 N2 NPLUS" $::actions
mc_check_actl_file 1 STEP2 "me-david.actl"
